[UTF-8]
[Use `iconv -f UTF-8', if needed]

2022-05-20 КриптоПро JCSP 5.0.42649-0086315f
* jcp: устранена ошибка, когда в установщике не создавался ярлык на панель управления, и добавлена возможность создать ярлык для всех пользователей (JCP-1989)
* jcp: устранена ошибка в консольном установщике при установке модулей поддержки (JCP-1999)
* jcp: при вводе лицензии JCP и использовании модуля шифрования JCrypto проверяется наличие поддержки шифрования в лицензии (JCP-1901, JCP-1984)
* jcp: сделано несколько оптимизаций в логгере для лучшей скорости логирования, некоторое методы логгера изменили название (JCP-1990, JCP-2003)
* jcp: добавлен метод decodeRequest в GostCertificateRequest для декодирования запроса, Request API для УЦ 1.5 отмечено, как deprecated (JCP-1545)
* jcp: в установщике улучшено определение провайдера по умолчанию (JCP-1949)
* jcp: добавлен параметр -rutoken для консольного установщика (JCP-2002)
* jcp: добавлен пакет Doc/keytool с примерами работы с keytool (JCP-1599)
* revcheck: добавлена возможность использовать строго реализацию алгоритма PKIX провайдера JCPRevCheck вместо стандартного PKIX с помощью параметра disable_default_pkix или RevocationSettings (JCP-1939)
* revcheck: в Android данные сертификата/CRL при скачивании предварительно помещаются в буфер (JCP-1939)
* revcheck: протокол LDAP в AIA/CRLDP недоступен и не используется (JCP-1961, JCP-1939)
* jcsp: устранена ошибка при работе с системными хранилищами в службе ключей, улучшена скорость чтения сертификатов (JCP-1964)
* jcsp: устранена ошибка OutOfMemory при использовании VoidInputStream в PFXSTORE (JCP-1996)
* jcsp: доработан логгер CAPILogger (JCP-2003)
* cades: сделано несколько оптимизаций для лучшей скорости создания EnvelopedSignature (JCP-1993)
* cades: добавлена возможность перечитать хранилище доверенных корневых сертификатов для обновления списка доверенных корневых сертификатов (JCP-1991)
* tls: реализована поддержка лицензии TLS Client в КриптоПро CSP в случае использования Java CSP (NGATE-3117)
* tls: добавлена возможность отключить проверку присутствия сертификата клиентской цепочки в списке издателей с помощью параметра tls_client_disable_issuer_check или JavaTLSCertPathManagerParameters (JCP-1977)
* tls: обновлен адаптер JCPTomcatAdapter.jar для tomcat 9+ (JCP-1794)
* docs: обновлена документация (issue #1, JCP-1294, JCP-1806, JCP-1851, JCP-2001, JCP-2006, JCP-2009)
* internal: JCP-1910, JCP-1204, JCP-1464

2022-03-04 КриптоПро JCSP 5.0.42465-8983dc24
* jcp: в провайдере зарегистрирована реализация MAC с именам алгоритмов ключей Кузнечик/Магма (JCP-1805, JCP-1623)
* jcp: в дистрибутив добавлены новые корневые сертификаты Минкомсвязи, КриптоПро и др. (JCP-1897, JCP-1882)
* jcp: ускорены операции с ключом на алгоритме Кузнечик (JCP-1794)
* jcp: сделан ряд оптимизаций при работе кривыми Эдвардса (JCP-1881, JCP-1843, JCP-1844, JCP-1845)
* jcsp: добавлена поддержка экспорта/импорта с помощью алгоритма MGM_*_EXPORT для ключей Кузнечик/Магма (issue #45)
* jcsp: добавлена поддержка работы с ключами, закэшированными службой хранения ключей, путем включения параметра -Dcsp.cache=true (JCP-1869)
* jcsp: добавлена генерация ошибки, если установка KP_ALGID не поддерживается (JCP-1856)
* jcsp: устранены ошибки при работе с алгоритмами Кузнечик/Магма в AIX (JCP-1898)
* jcsp: обновлена библиотека libcspjni для AIX (JCP-1899)
* jcsp: устранено обращение в сеть при построении цепочки сертификатов из PFX или системного хранилища (JCP-1868)
* rutoken: модуль поддержки убран из установки по умолчанию (JCP-1871, JCP-1929)
* tls: упрощено формирование блока для вычисления имитовставки, упрощено формирование IV с инкрементом при шифровании записи (JCP-1794)
* tls: добавлена проверка лицензии Java CSP при проверке лицензии Java TLS в клиентской ОС при создании серверного сокета (JCP-1935)
* tls: добавлена проверка серверности лицензии JCP при проверке лицензии Java TLS (JCP-1890)
* cades: добавлена проверка бита key_agreement в расширении "использование ключа" сертификата получателя (JCP-1848)
* xades: устранена ошибка, когда при поиске доказательства по ссылке не учитывались миллисекунды (JCP-1895)
* docs: обновлена документация, добавлено описание алгоритмов Кузнечик/Магма и примеры (JCP-1623, JCP-1874)

2021-11-15 КриптоПро JCSP 5.0.42109-9be8db6e16
* jcp: устранена ошибка при диверсификации ключей с алгоритмами Магма и Кузнечик (JCP-1794)
* jcp: добавлена возможность с помощью класса KdfTreeDiversKeySpec использовать алгоритм диверсификации ключа CALG_KDF_TREE_GOSTR3411_2012_256 (JCP-1772)
* jcp: добавлены примеры шифрования с использованием алгоритмов Магма и Кузнечик (JCP-1805)
* jcp: в дистрибутив добавлена папка с корневыми сертификатами Минкомсвязи, КриптоПро и др. (issue #41)
* jcsp: добавлена поддержка ОС Эльбрус-8C (e2k) (JCP-1783)
* jcsp: устранена ошибка при работе провайдера в ОС AltLinux 8x64 SP (JCP-1663)
* jcsp: устранена ошибка чтения хранилища в формате CertStore (JCP-1812)
* jcsp: добавлена возможность экспорта ключевого контейнера в формат PFX с помощью keytool при установленном провайдере Java TLS (issue #53)
* tls: клиент в случае получения ServerHello с EMS продолжает работать с поддержкой EMS независимо от криптонабора, выбранного сервером (JCP-1819)
* tls: сервер в случае получения ClientHello с EMS и выборе старого криптонабора ff85 или 0081 не отправляет EMS в ServerHello, как будто не поддерживая EMS, и продолжает работать без EMS (JCP-1819)
* tls: скорректирована регистрация TLS алгоритмов в провайдере (JCP-1819)
* tls: скорректированы лимиты в счетчиках сообщений (JCP-1821, issue #42)
* tls: скорректирована обработка сообщений хендшейка (JCP-1821)
* tls: при renegotiation клиент отправляет список криптонаборов в соответствии с ранее выбранным протоколом (JCP-1830)
* tls: добавлена возможность построить цепочки сертификатов выбираемых ключевых контейнеров в SSLContext (JCP-1818)
* tls: добавлен тип хранилища "HDImageFile" в провайдер JTLS для случаев работы с хранилищем ключей KeyStore, требующих поток ввода в методе load (JCP-1751)

2021-09-08 КриптоПро JCSP 5.0.42050-f86914188e
* jcp: минимальная поддерживаемая версия - Java 1.8.0_100+ (issue #43)
* jcp: реализована поддержка криптонаборов ГОСТ TLS 1.2 с использованием алгоритмов Кузнечик/Магма (JCP-1316)
* jcp: добавлено исключение комментариев при анализе файлов ОС для определения ее серверности (JCP-1788)
* jcp: в revocation-провайдер добавлена возможность потребовать проверку подписи CRL (как в Microsoft) вместо простой проверки издателя (как в RFC) при подборе CRL в ходе
       проверки цепочки сертификатов с помощью параметров JCPPKIXBuilderParameters или ru.CryptoPro.reprov.use_ms_verify (JCP-1733)
* jcsp: устранена ошибка в генераторе секретных ключей, приводящая к ошибке при создании ключа в keytool (JCP-1790) 
* jcsp: устранена ошибка в работе isCertificateEntry, приводящая к NPE в jarsigner при подписи jar-файла (issue #17)
* jcsp: добавлен ДСЧ "HardwareRandom" с установкой PP_USE_HARDWARE_RNG (JCP-1651)
* jcsp: добавлена возможность с помощью класса KdfTreeDiversKeySpec использовать алгоритм диверсификации ключа CALG_KDF_TREE_GOSTR3411_2012_256 (JCP-1770)
* jcsp: добавлена возможность указать при импорте PublicKeySpec для создания открытого ключа требование последующего экспорта открытого ключа в getDecoded() с помощью
       CryptExportKey, а не брать значение из кеша (JCP-1759)
* jcsp: добавлена возможность с помощью MarkExportableParameterSpec задать экспортируемость ключа в генераторе (JCP-1758)
* jcsp: устранена ошибка при создании секретных ГОСТ ключей 28147/Магма/Кузнечик непосредственно в ключевом контейнере и их копировании (JCP-1612)
* jcsp: добавлена поддержка операции KP_ADDX (JCP-1745)
* jcsp: добавлена поддержка операции KP_MULX (JCP-1735)
* jcsp: добавлена поддержка r-mask для RSA (JCP-1740)
* tls: добавлена поддержка расширения Extended Master Secret (issue #43)
* tls: устранена ошибка преждевременного удаления ключа в SSL-сессии (JCP-1762)
* tls: исправлена работа TLS в Samsung Android Knox путем уточнения имени провайдера при создании криптографических объектов (JCP-1747)

2021-06-21 КриптоПро JCSP 5.0.41975 (e478bb116a)
* jcp: добавлена поддержка набора OID для коротких кривых (JCP-1725, JCP-1707)
* jcp: в JCP добавлена поддержка алгоритмов шифрования Магма/Кузнечик, расширен CheckConfFull (JCP-1717, JCP-1685, JCP-1661, JCP-1315)
* jcp: добавлена проверка алгоритма объекта хеширования в setParameter реализации Signature (JCP-1734)
* jcp: устранена ошибка в JarChecker, возникающая при смене параметров шифрования по умолчанию (JCP-1724)
* jcp: в панели управления устранена ошибка при копировании ключа в контейнер без пароля (JCP-1729)
* jcp: ослаблена обфускация некоторых пакетов (JCP-1727)
* jcp: в JCP улучшено определение серверности ALT Linux (JCP-1674)
* jcp: в установщике исправлена версия BC с 1.50 на 1.60 (JCP-174)
* jcp: при удалении контейнера в панели управления, если не задан пароль, будет сообщено об ошибке (issue #55)
* jcsp: устранена ошибка подсчета HMAC при длине данных, большей 1024 байта (JCP-1743)
* jcsp: добавлена проверка алгоритма объекта хеширования в setParameter реализации Signature (JCP-1734) 
* jcsp: расширена проверка алиаса ключа/сертификата при чтении из системного хранилища или PFX (JCP-1720)
* jcsp: добавлена возможность экспорта/импорта секретных ключей на алгоритме Магма/Кузнечик на секретном ключе с другим алгоритмом (JCP-1717)
* jcsp: добавлена поддержка набора OID для коротких кривых (JCP-1725, JCP-1707)
* jcsp: устранена ошибка с усложнением ключа для CMS (JCP-1315)
* jcsp: устранена ошибка работы в режиме strict mode в Android (JCP-1693, JCP-1696, JCP-1687)
* jcsp: исправлена ошибка, когда CryptContextAddRef мог быть не выполнен (JCP-1689, JCP-1677)
* jcsp: исправлена ошибка в использовании Log.isLoggable, приводящая к крэшу в Samsung с Android 11 (JCP-1678)
* jcsp: в генераторе эфемерной пары формирование закрытого ключа опирается на тип генератора (JCP-1675) 
* jcsp: для ускорения работы перераспределены и изменены блокировки при обращении к CryptoAPI (issue #52)
* jcsp: скорректировано получение OID'ов для ключей шифрования и согласования, теперь не делается лишних записей в лог (issue #52)
* jcsp: для ускорения работы изменен порядок закрытия контекста провайдера (issue #52)
* jcsp: перед выполнением CryptImportKey в некоторых случаях во избежание ERROR_BUSY добавлено клонирование ключа импорта (issue #52)
* jcsp: расширены возможности использования пулов контекстов в некоторых случаях, 
  для сессионных ключей: -Duse_secret_context_pool=true -Dsecret_context_pool_size=[size]
  для ПДСЧ:              -Duse_random_context_pool=true -Drandom_context_pool_size=[size]
  для хеша:              -Duse_hash_context_pool=true   -Dhash_context_pool_size=[size]
  При создании кешей контекстов будет использован CSP провайдер по умолчанию из панели управления (issue #51, #52)
* jcsp: для ускорения работы расширено кеширование информации: OID'ы, алгоритм ключа, признак иностранного ключа и др. (issue #52)
* jcsp: для ускорения работы выполнен рефакторинг кода с целью сокращения числа CryptoAPI операций (issue #52)
* jcsp: добавлена возможность читать и сохранять симметричные ключи на ГОСТ алгоритме в ключевом контейнере (issue #52)
* jcsp: выполнен рефакторинг кода обращения с ключами - объединены кодовые базы ГОСТ ключей и иностранных (issue #52)
* jcsp: добавлен параметр -Dhandle_check=[true|false] для управления контролем контекстов (HSM) при экспорте ключа (issue #52)
* cades: при создании enveloped cms (agree) на сессионном ключе ГОСТ 28147 для получателя на алгоритме ГОСТ 2012 (512) ставится OID экспорта/импорта id_tc26_agreement_gost_3410_2012_256 (JCP-1722)
* cades: выполняется подпись DER кодированных подписанных атрибутов, расширена проверка криптографической подписи в случае ошибки (JCP-1664, JCP-1672)
* cades: выполнен рефакторинг кода формирования и проверки архивной подписи и штампов времени, введено ограничение на число штампов в подписи при ее усовершенствовании (JCP-1664, JCP-1671)
* cades: доработан механизм формирования ats-hash-index-v3 в архивной подписи (JCP-1664, JCP-1665, JCP-1666)
* cades: добавлено усовершенствование штампа на доказательства при усовершенствовании X Long Type 1 до архивной подписи (issue #39)
* cades: скорректировано хеширование SignerInfo для архивной подписи при создании и проверке архивного штампа (JCP-1519)
* tls: устранена ошибка в работе сюиты TLS_GOSTR341112_256_WITH_MAGMA_CTR_OMAC (JCP-1701)

2021-02-04 КриптоПро JCSP 5.0.41845
* jcsp: добавлена поддержка system store (MY, CA, ROOT, AddressBook, sst) (JCP-578)
* jcsp: размер данных CryptGetProvParam определяется более точно (issue #40)
* tls: устранена ошибка в счетчике сообщений (issue #42)

2021-01-25 КриптоПро JCSP 5.0.41836
* jcp: в RevCheck аналогично -Dallow_crl_redirect=true (CRLDP) добавлена возможность указать параметр -Dallow_cert_redirect=true для обработки переадресации при обращении к AIA (issue #28)
* jcsp: добавлен экспорт ключей и сертификатов в PFX, доработан импорт в PFX (JCP-1564, issue #24)
* jcsp: ускорено формирование и проверка Signature-подписи (JCP-1655)
* jcsp: улучшено формирование имени временного ключевого контейнера (JCP-1564)
* jcsp: экспортность лицензии определяется с помощью PP_EXPORT_CSP (issue #40)
* cades: введена более строгая проверка сертификатов подписантов подписи XLT1 или A и служб на предмет требования доказательств, убраны лишние проверки в архивном штампе (JCP-1656)
* cades: устранена ошибка проверки штампа на доказательства в архивной подписи и расчета хеша для ats-hash-index при наличии в подписи сертификатов и CRL (issue #39)
* cades: устранена ошибка расчета хеша при создании архивной подписи в случае RAW-подписи (issue #36)

2020-12-09 КриптоПро JCP 2.0.41789
* jcp: добавлен метод getCertificateAlias (issue #2)
* jcp: доработано декодирование расширения со сроком действия ключа (issue #8)
* jcp: улучшен алгоритм проверки ключевой пары на соответствие (issue #20)
* jcp: устранена ошибка задания некорректного пароля в окне при копировании контейнера (issue #22)
* jcp: устранена ошибка при открытии пустого хранилища ключей (issue #21)
* jcsp: добавлен экспорт ключей и сертификатов в PFX (JCP-1564)
* jcsp: доработан метод getCreationDate (JCP-1452)
* jcsp: добавлена возможность получить открытый ключ по закрытому ключу на алгоритме RSA (issue #4)
* jcsp: исправлена ошибка не установки паддинга при шифровании с помощью ключа RSA (issue #5)
* jcsp: доработана проверка доверия к открытому ключу на алгоритме RSA (issue #11)
* jcsp: доработан алгоритм определения типа провайдера по имени хранилища, когда не задан провайдер 75 типа (issue #14)
* jcsp: в панель управления добавлена сортировка имен считывателей по алфавиту (issue #15)
* jcsp: увеличен список классов для поддержки считывателей CSP (issue #18)
* cades: добавлена возможность отключить проверку цепочки сертификатов на отзыв при создании подписи формата BES или T (JCP-1643, issue #3)
* tls: удалена попытка обращения к X.509 BC (issue #6)
* tls: параметр disable_default_context для отключения инициализации дефолтного контекста по умолчанию теперь false (issue #9)

2020-11-16 КриптоПро JCP 2.0.41752
* jcp: обновлена версия зависимости bouncycastle с 1.50 до 1.60, json с 20080701 до 20180813, commons-logging с 1.1.1 до 1.2 (JCP-1566)
* jcp: в установщике 2.0 обновлено лицензионное соглашение (JCP-174)
* jcp: в диагностический CheckConfFull добавлена очистка кеша сертификатов, открытых ключей и CRL (JCP-174)
* jcp: в HDImageStore добавлен -get - способ получения папки с ключевыми контейнерами, улучшена работа Check (JCP-1586) 
* jcp: улучшена работа панели - проверка ключа на экспортируемость перед копированием, обновление списка контейнеров,
       конкретизация ошибок (JCP-1054, JCP-1064)
* jcp: добавлена сортировка узлов с ключевыми контейнерами в панели управления (JCP-1147, JCP-1641)
* jcp: улучшено отображение окон панели в ОС Debian при запуске под управлением пользователя (JCP-1272)
* jcp: добавлена возможность использовать для хранения настроек Preferences файловое хранилище в ОС Windows (JCP-1404)
* cades: устранена ошибка удаления ранних архивных штампов в CAdES-A (JCP-1544)
* cades: доработана процедура формирования и проверки подписи формата CAdES-A:
         при усовершенствовании, если последний неусовершенствованный архивный штамп, он усовершенствуется,
         при внутренней проверке усовершенствованного архивного штампа на момент самого штампа принимаются доказательства из будущего,
         при проверке последнего усовершенствованного архивного штампа цепочка его подчиненного УЦ проверяется на текущий момент,
         при проверке, если последний архивный штамп - неусовершенствованный, то он проверяется на текущий момент (JCP-1544)
* cades: устранена ошибка непреднамеренного кеширования хеша подписантом (JCP-1594)
* cades: устранена ошибка 405 при скачивании CRL (JCP-1573)
* cades: теперь при формировании OCSP запроса алгоритм хеширования определяется по алгоритму ключа сертификата.
         По умолчанию алгоритм хеширования в TSP запросе определяется по алгоритму ключа сертификата подписи.
         Добавлена более точная передача имени провайдера (JCP-1580)
* cades: ускорено формирование CAdES-A подписи в случае использования при усовершенствовании алгоритма хеширования, отличного от алгоритмов хеширования подписанта или штампа времени (JCP-1608)
* jcsp: добавлена генерация секретного ключа на алгоритме DES (JCP-1585)
* jcsp: теперь секретные ключи на алгоритме AES, 3DES, DES по умолчанию генерируются в памяти (JCP-1585)
* jcsp: добавлена возможность ускорить проверку подписи с помощью -Duse_public_key_fast=true (JCP-1621)
* jcsp: улучшено копирование ключевых контейнеров (JCP-1585)
* jcsp: добавлен экспорт/импорт секретного ключа с алгоритмом AES, 3DES, DES на ключе RSA, добавлен пример (JCP-1584)
* jcsp: добавлен экспорт/импорт секретного ключа с алгоритмом AES, 3DES, DES на аналогичном секретном ключе, добавлен пример (JCP-1607)
* jcsp: если секретный ключ создается или копируется в существующий контейнер, то генерируется ошибка, перезапись запрещена (JCP-1606) 
* jcsp: добавлена поддержка NoPadding для иностранных секретных ключей (JCP-1603)
* jcsp: ключи теперь реализуют интерфейс Destroyable (JCP-1462)
* jcsp: в режиме отображения UNIQUE-имен в "Хранилищах ключей и сертификатов" при копировании контейнера теперь пустое поле для ввода имени контейнера (JCP-1398)
* jcsp: DiversKeySpec теперь расширяет SecretKey (JCP-560)
* tls: устранена ошибка неправильной передачи distinguished names в случае превышения размера списка 64Кб (JCP-1579)
* tls: в SSLSessionImpl теперь передается цепочка сертификатов (JCP-1649)
* tls: версия OkHttp в примерах увеличена до 4.8 (JCP-1554)
* tls: расширен список функций инициализации защищенного контекста в TLSContext (JCP-1552)
* tls: упрощен код создания cipher suite в cpSSL и определение размера IV (JCP-1601)
* xades: устранена ошибка получения реализации XML алгоритма хеширования и подписи (XMLDSigRI) в Java 1.8.0_13+ (JCP-1569)
* xml: добавлена возможность для JCPxml указать провайдер подписи с помощью JCEMapper.setProviderId() (JCP-1596)

2020-07-23 КриптоПро JCP 2.0.41618
* jcp: улучшена работа хранилища SecretStore под нагрузкой, улучшена его производительность (JCP-1507)
* jcp: добавлена обработка критического расширения 1.3.6.1.4.1.311.20.2 (OID_ENROLL_CERTTYPE_EXTENSION) в сертификате (JCP-1520)
* jcp: редактирование ячеек таблицы на вкладке «Дополнительно» запрещено (JCP-1538)
* jcp: в папку Doc/docker дистрибутива добавлены примеры использования в docker'е (JCP-1501)
* rutoken: исправлена ошибка с чтением/записью данных длиной 0x34 + k*0x40 (JCP-1497)
* rutoken: добавлен RutokenStoreParameter для получения серийного номера токена, скрыта часть внутренних методов (JCP-1542)
* jcsp: устранена возможная ошибка дублирования объекта ключа типа CLOUD при его чтении (JCP-1487)
* jcsp: добавлена работа с RSA ключами в панели управления (JCP-1418, JCP-1535, JCP-1536, JCP-1537)
* cades: ряд изменений в алгоритме добавления и проверки архивных штампов: 
         при усовершенствовании архивный штамп добавляется сразу усовершенствованным,
         проверка усовершенствованного штампа выполняется на момент самого штампа,
         при усовершенствовании добавление нового архивного штампа возвращает ошибку, если предыдущий штамп не имеет доказательств (JCP-1524)
* cades: сделан ряд исправлений в формате архивной подписи CAdES-A в соответствии с рекомендациями стандарта CAdES (JCP-1509, JCP-1510, JCP-1511, JCP-1512)
* cades: добавлена поддержка атрибута ats-hash-index-V3, теперь он используется по умолчанию при создании архивной подписи CAdES-A (JCP-1508, JCP-1513)
* xades: при поиске сертификатов перед проверкой X Long Type 1 дополнительно используются сертификаты из KeyInfo (CADES-2087)
* tls: устранено требование серверной лицензии TLS при использовании SSLEngine в режиме клиента (JCP-1547)
* tls: улучшена передача исключений при подборе ключевого контейнера в KeyManager (JCP-1522)
* tls: добавлена возможность при проверке цепочки сертификатов использовать CRL, переданный в TrustManager (JCP-1516)
* pdf: добавлена библиотека itextpdf 5.5.5-2 с возможностью установить CAdES подпись в документе (JCP-1417)

2020-05-12 КриптоПро JCP 2.0.41473
* jcp: переработан SelfTester - он разделен между модулями, улучшена его производительность (JCP-1436)
* jcp: понижен уровень логирования в некоторых функциях (JCP-174)
* jcp: исправлена ошибка декодирования сертификата, обновлены классы модулей JCPRevCheck, JCPRevTools (JCP-1466)
* jcp: внесены исправления в документацию (JCP-1419, JCP-1464)
* jcp: cmsutil и tls_proxy не содержали весь комплект файлов (JCP-1473)
* jcp: улучшен просмотр ключей без сертификатов в keytool (JCP-1471)
* jcsp: исправлена ошибка при экспорте/импорте премастер-ключа в TLS в части использования SIMPLE_EXPORT (JCP-1498)
* jcsp: расширена инициализация графических библиотек для корректной работы CSP ДСЧ в MAC OS (CPCSP-10367)
* jcsp: уточнены реализации алгоритмов в провайдерах JCSP и JCSPRSA (JCP-872)
* jcsp: убрано клонирование master-ключа при использовании в TLS (JCP-1397)
* jcsp: модуль получил правильный Git-Hash атрибут в META-INF/Manifest.MF (JCP-1426)
* jcsp: добавлена возможность получить исключение WrongPasswordException в случае неправильного пароля PFX для CSP 5.0.11729 и выше (JCP-1443)
* jcsp: в cmsutil улучшена работа с облачным контейнером (JCP-1478)
* tls: клиент больше не отправляет расширение TLSGostExtensionHashHMACSelect в ClientHello, клиент и сервер проверяют расширение только в случае использования TLS_CIPHER_2001 (JCP-1424)
* tls: в экспериментальном режиме в TLS v.1.2 добавлена поддержка cipher suites с использованием алгоритмов Кузнечик/Магма (JCP-1397)
* tls: добавлена поддержка TLS_CIPHER_2012_IANA (JCP-1326)
* tls: удаление хендла ключа перемещено в кэш сессий (JCP-1116)
* tls: расширен список "белых функций" инициализации TLS с помощью класса TLSContext (JCP-1425)
* tls: алгоритм проверки соответствия хоста и сертификата сервера на клиенте выведен из-под зависимости от tls_prohibit_disabled_validation (JCP-1467)
* cades: OID алгоритма ключа в CAdES подписи всегда алгоритм ключа подписи (JCP-1383)
* cades: в EnvelopedSignature устранена ошибка добавления пустых unprotected-атрибутов (CPCSP-10847)

2020-01-25 КриптоПро Java CSP 5.0.40714, Android CSP 5.0.40714
* jcp: доработан обработчик содержимого критического расширения APP_CERT_POLICIES для сертификата TSP службы (JCP-1336)
* jcsp: иностранные алгоритмы регистрируются, только если установлен RSA CSP (JCP-1416)

2020-01-16 КриптоПро Java CSP 5.0.40709, Android CSP 5.0.40709
* jcp: сделано переподключение к токену, ожидание блокировки для Rutoken (JCP-1297)
* jcp: оптимизация работы RutokenStore (JCP-1345)
* jcp: исправлена ошибка декодирования открытого ключа ГОСТ 2012 без параметров хеширования (JCP-1367)
* jcp: расширена документация (JCP-1334, JCP-1353)
* jcp: удалены модули OCF и Oscar (JCP-1347)
* jcp: модули cmsutil и tls_proxy теперь содержат номера версии и сборки (JCP-1370)
* jcp: в MANIFEST.MF jar-файлов добавлен атрибут Git-Hash (JCP-1374)
* jcp: в алгоритм подписи CMS всегда помещается OID алгоритма ключа подписи (JCP-1383)
* jcp: из создаваемого при установке JCP ярлыка для запуска панели управления JCP убрано заполнение поле  "рабочая папка" (JCP-1381)
* jcp: добавлен обработчик содержимого критического расширения APP_CERT_POLICIES для сертификата TSP службы при наличии расширения (JCP-1336)
* jcp: в CertStore добавлена смена ключа (JCP-1407)
* jcsp: изменена лицензионная политика JCSP - требование серверной лицензии при работе в серверной ОС, в клентской ОС лицензия не требуется (JCP-1352)
* jcsp: добавлена поддержка алгоритмов шифрования Кузнечик/Магма для шифрования и в EnvelopedSignature (JCP-1312, JCP-1314)
* jcsp: улучшена работа с PUBLICKEYBLOB и SIMPLEBLOB, добавлено преобразование PUBLICKEYBLOB в PublicKey, экспорт в виде SIMPLEBLOB, изменен порядок установки KP_ALIGD в Mac и Cipher (JCP-1337)
* jcsp: импорт/экспорт сессионного ключа выполняется в рамках одного контекста (JCP-875)
* jcsp: добавлен повторный импорт открытого ключа в случае ошибок при его использовании (JCP-1308)
* jcsp: добавлена возможность приведения открытого ключа JCP к виду Java CSP при операции проверки подписи и ВКО (JCP-1308)
* jcsp: добавлена поддержка PFXSTORE - чтение ключей и сертификатов (JCP-1000)
* jcsp: объединены провайдеры JCSP и JCSPRSA (JCP-872)
* jcsp: устранены утечки хендлов в Cipher при работе в EnvelopedSignature и самом EnvelopedSignature (JCP-1351)
* jcsp: добавлен функционал для сравнения ключей на их соответствие друг другу (JCP-1122)
* jcsp: изменена работа провайдера в плане запроса пароля при создании контейнера без пароля - при создании можно явно указать, что контейнер без пароля (JCP-1338)
* jcsp: расширено логирование вызовов CryptoAPI: CAPILogger, JCSPLogger (JCP-1308)
* jcsp: CheckConfFull теперь использует тип контейнера по умолчанию, а не строго HDIMAGE в *nix и REGISTRY в Windows (JCP-1400)
* cades: добавлена поддержка в EnvelopedSignature (key_trans, key_agree) алгоритмов Кузнечик/Магма (JCP-1341, JCP-1314)
* cades: добавлена проверка сертификата оператора TSP службы на наличие политики timestamping (JCP-1323)
* cades: при поиске OCSP-доказательства проверяется также время его создания (CADES-1725, JCP-871)
* cades: скорректирован алгоритм проверки KeyUsage в сертификате - при критичном KeyUsage проверяется наличие digitalSignature при проверке подписи и keyEncipherment при шифровании key_trans (JCP-1142, JCP-1155)
* tls: улучшен выбор ДСЧ при создании защищенного контекста (JCP-1331)
* tls: добавлена проверка алгоритмов ключей в цепочке сертификатов на соответствие ГОСТ и используемых провайдеров на соответствие JCP, Crypto или Java CSP (JCP-1334)
* tls: исправлена ошибка при определении значения параметра tls_prohibit_disabled_validation (JCP-1390)
* tls: обновлен JCPTomcatAdapter (JCP-1413)
* android: повышен API Level, minSdk = 24 (7.0), targetSdk = 28 (9.0) (JCP-1338)
* android: улучшена работа приложений в android 8-9 (JCP-1240, JCP-1361, JCP-1362, JCP-1369, JCP-1373, JCP-1379)
* android: доработки для поддержки рутокенов в android 8-9, обновлены модули рутокена (JCP-1350)
* android: провайдер требует лицензии только CSP 5.0, экспортные истекшие лицензии 4.0 в ACSP и ACSPClientApp заменены на экспортные истекшие лицензии 5.0 (JCP-1348)
* android: возвращена версия xmlsec 1.4 для android-приложений, улучшена совместная работа XAdES и xmlsec 1.4 (JCP-1235)
* android: добавлена фильтрация символов для пароля в окне ввода пароля (JCP-1176)
* android: сделана возможность добавить файл с хешами библиотек в приложение, использующее sdk, для контроля целостности этих библиотек (JCP-1335)
* android: добавлено игнорирование LDAP-ссылок в CRLDP (JCP-1333)
* android: добавлены примеры работы с алгоритмами шифрования Кузнечик и Магма (JCP-1314)
* android: добавлена возможность скопировать лог в буфер обмена в ACSPClientApp (JCP-1262)
* android: в настройках ACSP хранилище HDIMAGE всегда активно и заблокировано (JCP-1260)
* android: исправлена ошибка необновления списка контейнеров в ACSPClientApp (JCP-1360)
* android: исправлена ошибка недостаточности прав в ACSPClientApp (JCP-1277)
* android: из ACSPInClientApp убрано переопределение свойств *.ssl и javax.net.*, в ACSPClientApp расширено описание по работе с TLS-параметрами (JCP-1389)
* android: расширен список корневых сертификатов, добавлена проверка срока действия устанавливаемых сертификатов (JCP-1393)
* android: исправлен пример работы с УЦ 1.5 (JCP-1391)
* xades: поддержка и переход на формирование SigningCertificateV2 и CompleteCertificateReferencesV2, время UTC Z (JCP-871)

2019-08-08 КриптоПро JCP 2.0.40502
* jcp: убраны информативные сообщения об ошибках для рутокена (JCP-1290, 1291)
* jcp: исправлена ошибка перечисления сертификатов контейнеров с помощью keytool -list (JCP-1295)
* jcp: добавлен вывод детального сообщения об ошибке для J6CF в панели управления (JCP-1267, JCP-1293)
* jcp: исправлена ошибка при отображении и добавлении сертификата без CN (JCP-1301)
* jcp: расширено описание команд keytool, расширена документация (JCP-1225)
* jcsp: исправлена ошибка при проверке лицензии в сертификате (JCP-1286)
* jcsp: сделана возможность в панели создать или добавить неэкспортируемый ключ (JCP-1279)
* jcsp: добавлен вывод даты создания контейнера по сертификату (JCP-1282)
* cades: добавлен вывод серийного номера сертификата в случае ошибки построения или проверки цепочки в CAdES/XAdES (JCP-1284)
* tls: устранена ошибка приведения типов при использовании javax.net.ssl.keyStore (JCP-1296)
* android: улучшена работа панели управления ACSP и вкладок приложений (JCP-1263, JCP-1264)
* android: устранен крэш android-приложений, если лицензия CSP - просрочена (JCP-1259)

2019-07-08 КриптоПро JCP 2.0.40424, Java CSP 5.0.40424, Android CSP 5.0.40424
* jcp: возвращена проверка соответствия алгоритмов ключа и подписи в Signature, доработка панели JCP (JCP-1244)
* jcp: добавлен запрет на EXTERNAL_ENTITIES для DocumentBuilderFactory (JCP-1248)
* jcp: добавлены параметры для задания таймаутов скачивания сертификатов при построении и проверки цепочки сертификатов (JCP-1236)
* jcp: изменения в JarChecker, позволяющие в случае Java CSP использовать провайдер CSP по умолчанию (JCP-1246)
* jcp: улучшен метод получения версии jar (JCP-1218)
* jcp: по умолчанию в GostTransport используется PRO_EXPORT (JCP-1254)
* jcsp: возвращена проверка соответствия алгоритмов ключа и подписи в Signature (JCP-1244)
* jcsp: расширен класс NameAlgId*Spec для передачи имени провайдера CSP при создании контейнера (JCP-1246)
* jcsp: добавлены логгеры JCSPLogger, CAPILogger (JCP-814)
* jcsp: добавлена возможность выполнить HMAC (ГОСТ) с выработкой ключа из хеша (JCP-1082)
* tls: добавлена проверка отключения проверки сертификата другой стороны в SSLContext, которую можно отключить -Dtls_prohibit_disabled_validation=false (JCP-1256)
* cades: улучшен поиск сертификатов по responderId, включающим только имя сертификата (JCP-1237)
* cades: реализована возможность добавить всю цепочку сертификатов подписанта в подпись (JCP-1250)
* cades: добавлена проверка наличия digitalSignature в сертификате подписи в CAdESSignature (JCP-1142)
* cades: добавлена проверка наличия keyEncipherment в сертификате получателя в EnvelopedSignature (JCP-1155)
* cades: добавлена возможность передавать пароль на cacerts (JCP-1249)
* xades: исправлена ошибка в определении типа подписи XAdES по атрибутам, расширен анализ типа подписи (JCP-1242)
* android: добавлены примеры подписи и проверки XAdES-подписи (JCP-1235)
* android: задан targetSdk=26 для android-приложений, внесены изменения в проекты demo-приложений (JCP-1234)
* android: улучшена работа с CertPathValidationException (JCP-1238)
* android: добавлена проверка отключения проверки сертификата другой стороны в SSLContext, которую можно отключить -Dtls_prohibit_disabled_validation=false (JCP-1256)

2019-04-25 КриптоПро Android CSP 5.0.40298
* android: добавлена поддержка архитектуры x64 (JCP-991)
* android: добавлена поддержка Rutoken ECP (USB Type-C)
* android: устранена ошибка при работе с токенами с недефолтным паролем (JCP-1227)
* android: устранена ошибка копирования только контейнеров, имеющих расширение папки, отличное от 000 (JCP-1144)
* android: добавлена фоновая инициализация в ACSP, кнопка выбора контейнера, блокирующие окна ожидания и улучшено отображение информации в ACSPClientApp (JCP-991, JCP-1179)
* android: заблокирован ввод паролей, содержащих буквы не английского алфавита (JCP-1176)
* android: добавлена обработка SERVER_NAME в ServerHello (JCP-1202)
* android: удалена фильтрация сертификатов по алгоритму ключа из CertificateRequest для TLS клиента (JCP-1211, JCP-1215)

2019-04-22 КриптоПро Java CSP 5.0.40291
* xml: устранен deadlock (JCP-1231)

2019-04-03 КриптоПро Java CSP 2.0.40277
* jcp: добавлена поддержка Liberica JDK (JCP-1200)
* jcp: запрещено копирование контейнера в панели управления, если контейнер с таким именем существует (JCP-1148)
* jcp: добавлена поддержка gost-transport-2012 для XML с PRO12_EXPORT (JCP-1201)
* jcp: улучшена поддержка keytool (JCP-1220)
* jcp: в документацию и примеры внесены исправления (JCP-1082, JCP-1150, JCP-1205)
* jcp: устранена ошибка при отображении версии jar (JCP-1218)
* jcsp: добавлена поддержка алгоритмов SHA384, SHA512, алгоритмов RSA подписи с ними, алгоритмов AES (128, 192, 256) и 3DES (генерация, сохранение/чтение/удаление ключа AT_SYMMETRIC), алгоритмов MAC X9.19 alg.3 и HMAC (3DES/AES), шифрования на ключах AES/3DES (ECB/CBC/CFB/OFB, PKCS5Padding/ZeroPadding) и RSA (CRYPT_RSA_PKCS /CRYPT_RSA_X_509), расширен NameAlgIdSpec (JCP-1181)
* jcsp: добавлен CRYPT_SILENT при перечислении контейнеров (JCP-1199)
* jcsp: устранены ошибки при работе в AIX (JCP-1189) 
* jcsp: исправлено отображение версии в панели управления (JCP-1163)
* jcsp: исправлена ошибка вычисления имитовставки на ключе согласования (JCP-1154)
* jcsp: улучшен алгоритм проверки наличия ключа в контейнере (JCP-1224)
* jcsp: улучшено перечисление контейнеров, когда зарегистрировано несколько однотипных провайдеров (JCP-1158)
* jcsp: в панель добавлена галка, разделяющая контейнеры по провайдерам. При этом к имени контейнера добавляется имя провайдера (JCP-1158)
* jcsp: добавлена проверка пароля с помощью PP_PIN_INFO (JCP-1085)
* jcsp: нить SelfTester теперь не запускает тесты JCP (JCP-1212)
* jcsp: устранены несколько утечек хендлов, добавлен -Dtrace_handle=true для вывода используемых хендлов дефолтным провайдером (JCP-1223)
* tls: удален 21 тип (Cert-Type) из перечисления в CertificateRequest (JCP-1161)
* tls: исправлена ошибка приведения типов при очистке сессии (JCP-1180)
* tls: удалена фильтрация сертификатов по алгоритму ключа из CertificateRequest для клиента (JCP-1211, JCP-1215)
* cades: добавлен флаг validate_other_tsp для проверки на отзыв цепочек штампов на доказательства и архивного

2018-11-12 КриптоПро Java CSP 2.0.40055
* jcp: запрещено создание и копирование контейнера, если контейнер с таким именем уже существует (JCP-1148)
* jcp: в примерах сокращено использование ГОСТ Р 34.10-2001 (JCP-1082)
* jcp: доработана документация (JCP-1082)
* jcsp: обновление списка считывателей происходит при каждой инициализации провайдера (JCP-814)

2018-11-01 КриптоПро JCP 2.0.40035
* jcp: улучшен макет и обработчик событий БиоДСЧ (JCP-1076)
* jcp: изменены названия наборов параметров подписи в панели управления (JCP-1095)
* jcp: исправлена функция добавления и удаления сервисов модулей поддержки (JCP-1132)
* jcp: добавлено определение ОС GosLinux (JCP-1135)
* jcsp: устранение утечек ресурсов CSP при клонировании объектов (JCP-1102, JCP-1117)
* tls: на закладке "Настройки сервера" удалена возможность отключить передачу RI клиентом (JCP-1081)
* tls: добавлены дополнительные проверки времени существования сессии (JCP-1116)

2018-10-26 КриптоПро Android CSP 5.0.40029
* android: расширена проверка архитектуры процессора (JCP-1123)
* android: исправлена ошибка при работе с кэшом списка считывателей в SDK (JCP-1121)

2018-10-23 КриптоПро Android CSP 5.0.40019
* android: добавлена поддержка архитектуры процессора x86 (JCP-1109)
* android: добавлен вывод хеша apk (JCP-997)
* android: добавлена возможность обновления списка cacerts при обновлении приложений (JCP-988)
* android: устранено появление лишнего сообщения при загрузке списка контейнеров (JCP-992)
* android: добавлена передача SNI клиентом при TLS подключении (JCP-707, JCP-1018)
* android: поправлен config провайдера, ускорено обновление списков в панели управления ACSP (JCP-1071)
* android: доработана функция копирования контейнера (JCP-984)
* android: устранена возможность downgrade'а приложения (JCP-1023)
* jcp: добавлена установка таймаутов в URICertStore в случае редиректа (JCP-1092) 
* jcp: добавлена возможность вызвать callback для ввода пароля пользователя в собственном окне при чтении ключа в KeyStore (JCP-1085)
* cades: добавлена поддержка подписи формата CAdES-A, рефакторинг алгоритма усовершенствования подписи (JCP-867)
* cades: устранена ошибка переполнения памяти при использовании CAdESSignature (JCP-897, JCP-1072)
* cades: добавлена возможность извлечь данные из совмещенной поточной подписи (JCP-1078)
* jcsp: добавлена возможность вызвать callback для ввода пароля пользователя в собственном окне при чтении ключа в KeyStore (JCP-1085)

2018-08-14 КриптоПро JCP 2.0.39894
* jcp: добавлена поддержка контейнеров нового типа из КриптоПро CSP 5.0 (JCP-865)
* jcp: добавлена возможность передать в генератор ключевой пары открытый ключ для извлечения параметров (JCP-982)
* jcp: исправлена ошибка - в шифратор не передавались параметры шифрования пользователя (Валидата CSP) (JCP-995)
* jcp: добавлена обработка исключений в провайдере RevCheck в случае ошибок при проверке подписи сертификата (JCP-1040)
* jcp: добавлено определение алгоритмов хеширования и подписи по ключу (JCP-1040)
* jcp: добавлена возможность работать с несколькими етокенами с помощью OCFStore (JCP-847)
* jcp: устранено создание пустой папки при копировании неэкспортируемого ключа (JCP-973)
* jcp: убрана проверка соответствия алгоритмов подписи и ключа при подписи Signature (JCP-1035)
* jcp: разрешено полное декодирование CRLDistributionPointsExtension независимо от ошибок в адресах CRLDP (JCP-1029)
* jcp: отключены проверки сроков действия алгоритма ГОСТ Р 34.10-2001 (JCP-943, JCP-795, JCP-1033)
* jcp: добавлено отключение БиоДСЧ по нажатию на ESC и кнопку отмены (JCP-1042)
* jcp: доработан инсталлятор (JCP-1039, JCP-1041, JCP-1044, JCP-1050)
* jcp: доработана панель (JCP-1059, JCP-1045)
* jcp: обновлена документация (JCP-981)
* jcsp: добавлена возможность передать в генератор ключевой пары открытый ключ для извлечения параметров (JCP-982)
* jcsp: добавлена возможность передать имя провайдера CSP в алиасе для JCSP (JCP-1001)
* jcsp: добавлена возможность передать в функцию вычислении имитовставки (Mac) ключ согласования (JCP-1016)
* jcsp: в классах Digest, Signature, Mac, Cipher, SecureRandom выполняется отложенная инициализация с целью сокращения потребления ресурсов CSP (JCP-1034)
* jcsp: добавлено определение алгоритмов хеширования и подписи по ключу (JCP-1040)
* tls: удалено явное определение ГОСТового провайдера подписи в параметрах при построении цепочки сертификатов другой стороны (JCP-1003)
* cades: доработано автоопределение типа подписи (JCP-1006)
* cades: добавлена возможность получить подписанные данные из совмещенной подписи (JCP-994)
* cades: добавлены примеры проверки подписи CAdES/XAdES в командной строке (JCP-999)
* cades: исправления в инсталляторе CAdES (JCP-977)
* cades: добавлен флаг -Dru.CryptoPro.AdES.require_alg_conformity=false для отключения проверки соответствия алгоритмов в addSigner (JCP-1014)
* cades: обновлена документация (JCP-986)
* xades: добавлена поддержка новых атрибутов (v2) в связи с обновлением стандарта (JCP-871)

2018-04-17 КриптоПро Android CSP 5.0.39755
* android: устранена ошибка обновления конфига при обновлении ACSP, доработаны активити (JCP-942, JCP-939, JCP-912)
* android: в ACSP доработано окно ожидания выполнения длительных операций (JCP-913)
* android: в ACSPClientApp добавлено окно ожидания при выполнении примеров в фоновом потоке (JCP-922)
* android: в ACSPClientApp изменены примеры шифрования, доработан алгоритм выбора ключа в cpSSL-android (JCP-927, JCP-979)
* jcsp: при использовании NameAlgIdSpec в генераторах ключей учитывается, были ли переданы параметры (JCP-924)

2018-04-11 КриптоПро JCP 2.0.39738
* jcp: доработана функция setKeyEntry, запрещена установка некольких ключей одного типа в контейнер (JCP-858)
* jcp: доработана вкладка "Хранилища ключей и сертификатов" в панели управления (JCP-843, JCP-884, JCP-894)
* jcp: модуль поддержки Rutoken интегрирован в JCP в виде RutokenStore (JCP-726)
* jcp: добавлена возможность отключить запрет на подпись ключом ГОСТ Р 34.10-2001 (JCP-795)
* jcp: исправлена ошибка передачи параметров шифрования при экспорте/импорте сессионного ключа (JCP-916)
* jcp: провайдер по умолчанию теперь определяется по его положению в java.security отдельной JRE (JCP-888, JCP-901)
* jcp: исправлена ошибка - ключ обмена на алгоритме ГОСТ 2001 всегда создавался экспортируемым (JCP-861)
* jcp: добавлен автовыбор БиоДСЧ при установке в зависимости от наличия в ОС графической оболочки (JCP-839)
* jcp: исправлена ошибка в функции getKey("") - теперь возвращает null вместо исключения (JCP-841)
* jcp: устранено зависание окна предупреждения об использовании ГОСТ Р 34.10-2001 (JCP-856)
* jcp: добавлен специальный параметр для скачивания CRL по https (JCP-876, JCP-880)
* jcp: улучшено логирование (JCP-564)
* jcp: добавлены новые примеры, расширены и обновлены старые: СМЭВ, enableAIAcaIssuers, шифрование (JCP-687, JCP-874, JCP-914, JCP-911)
* jcp: обновлена документация (JCP-812, JCP-840, JCP-898)
* cades: исправлена ошибка в установщике AdES-core.jar (JCP-864)
* xades: при подписи добавляется алгоритм каноникализации данных в узел штампа времени (JCP-860)

2018-03-12 КриптоПро Android CSP 5.0.39658
* android: обновлены модули поддержки rutoken (Lite SD и ECP BT) (JCP-844)
* android: добавлены примеры HttpsUrlConnection в ACSPClientApp (JCP-854)
* android: исправлено некорректное поведение вкладок приложений при их перезапуске (JCP-846)
* android: доработан алгоритм проверки лицензии в cpSSL-android (JCP-873)
* jcsp: исправлена ошибка при перечислении расширений контейнера (JCP-853)
* jcsp: добавлена возможность создать неэкспортируемый ключ шифрования ГОСТ 28147-89 (JCP-786)
* jcsp: добавлен провайдер JCSPRSA с поддержкой алгоритмов хеширования SHA1, SHA256 и подписи RSA, импорта JKS и др. (JCP-797)
* tls: доработан алгоритм проверки лицензии в cpSSL (JCP-873)
* cades: расширено логирование, добавлен вывод TSP, OCSP ответов и CRL в BASE64-формате (JCP-868)
* cades: расширена передача атрибутов подписи в штамп времени (JCP-889)
* cades: добавлена проверка цепочки сертификатов штампа времени (JCP-903)
* cades: добавлена возможность указать таймаут рассинхронизации TSP и OCSP служб при создании X Long Type 1 подписи (JCP-891)
* cades: добавлена возможность передать CRL для проверки штампа времени (JCP-887)
* cades: добавлена возможность передать CRL при создании или усовершенствовании подписи (JCP-907)
* cades: добавление доказательства для сертификата службы штампов внутреннего штампа (JCP-907)
* cades: доработан порядок проверки алгоритмов при формировании подписи (JCP-857)

2017-11-08 КриптоПро Android CSP 5.0.39473
* android: исправлена ошибка при перечислении расширений контейнера (JCP-853)
* android: исправлен формат даты проверки целостности (JCP-848)
* android: добавлены надписи на русском языке для окон CSP (JCP-842)
* android: добавлена возможность создать самоподписанный сертификат в приложении ACSPClientApp (JCP-845)

2017-10-30 КриптоПро Android CSP 5.0.39457
* android: обновлена версия провайдера CSP с 4.0 на 5.0 (JCP-761)
* android: добавлена возможность отключить предупреждение об ограничении сроков использования ГОСТ Р 34.10-2001 (JCP-823)
* android: добавлен sdk для встраивание провайдера Крипто-Про CSP в приложение (JCP-808)
* android: исправлена ошибка при отображении окна CSP с предупреждением (JCP-831, JCP-833)
* android: устранена ошибка при отображении имени контейнера в окне запроса пинкода в android 8.0 (JCP-832)
* android: исправлена работа с именами контейнеров (JCP-810)
* android: в ACSP установлена новая иконка (JCP-815)

2017-10-24 КриптоПро JCP 2.0.39442
* cades: исправлена ошибка при проверке подписи PKCS7 (JCP-799)
* jcp: исправлена ошибка при открывании и отображении контейнера в панели управления (JCP-798)
* jcp: исправлена ошибка декодирования сертификата с пустым полем в субъекте (JCP-809) 
* jcp: добавлен патч для itexpdf версии 5.5.5, библиотека добавлена в дистрибутив (JCP-568)
* jcp: исправлена ошибка при выводе окна уведомления об окончании сроке действия ГОСТ Р 34.10-2001 в системах без GUI (JCP-824)
* jcp: исправлена ошибка при декодировании цепочки сертификатов p7b в формате BASE64 с заголовками (JCP-784) 
* jcp: дописаны инструкции, обновлена документация (JCP-620, JCP-812, QA-65)
* jcp: исправлена ошибка при нажатии на кнопку Ок в панели управления под управлением учетной записи пользователя (JCP-834)

2017-06-28 КриптоПро JCP 2.0.39267
* android: в панели управления ACSP при копировании контейнера можно выбрать папки /mnt или /storage (JCP-735)
* android: добавлена возможность передать CRL при создании или проверке CAdES подписи в интентах ACSP (JCP-743)
* android: доработка окна ДСЧ для android 7.1 (JCP-747)
* android: в ACSPClientApp добавлен пример использования cmsutil (JCP-787)
* jcp: все провайдеры работают только в java версии 7 и выше (JCP-722)
* jcp: устранено удаление расширения алгоритма проверки срока действия ключа при установке цепочки сертификатов в контейнер (JCP-754)
* jcp: доработка определения типа системы для лицензии (JCP-728)
* jcp: исправления и доработки в инсталляторе (JCP-725, JCP-732, JCP-630)
* jcp: исправления в работе панели JCP с картами и токенами (JCP-733)
* jcp: добавлена возможность передачи алиаса ключа в StoreInputStream в JTLS (JCP-738)
* jcp: устранено дублирование записей JCPLogger (JCP-752)
* jcp: исправлена ошибка установки сертификатов из p7b (JCP-756)
* jcp: добавлены правила обфускации библиотек (JCP-767)
* jcp: обновлена документация (JCP-174)
* jcp: исправление ошибки сохранения параметров из установщика (JCP-768)
* jcp: в панели добавлена возможность установить в контейнер p7b в BASE64 (JCP-784)
* jcp: исправлены ошибки копирования и установки сертификата в контейнер на отделяемом носителе (JCP-781, JCP-782, JCP-783)
* jcsp: эфемерный ключ теперь всегда объект класса ключа обмена (JCP-729)
* jcsp: добавлена возможность получать список контейнеров компьютера (JCP-750)
* jcsp: добавлена возможность использовать уникальные имена контейнеров (JCP-751)
* jcsp: добавлена поддержка КриптоПро CSP 5.0 (JCP-761, JCP-766)
* jcsp: добавлена поддержка в cmsutil и tls_proxy (JCP-776)
* cades: добавлена проверка соответствия ключей при подписи (JCP-736)
* cades: исправлена ошибка при автоопределении типа подписи PKCS7 по атрибутам (JCP-760)
* cades: исправлена ошибка передачи сертификатов при усовершенствовании подписи (JCP-771)
* tls: устранена ошибка bad handshake record mac (JCP-692)
* tls: рефакторинг, добавлена поддержка ГОСТ TLS v. 1.1, 1.2, удалены сайфер-сюиты SSL3_CK_GVO_KB2, SSL3_CK_GVO (JCP-386)
* tls: отменена проверка количества подключений на сервере (JCP-773)
* tls: клиент по умолчанию шлет длину подписи в CertificateVerify (JCP-779)

2016-12-14 КриптоПро JCP 2.0.39086
* jcp: в инсталлятор добавлена возможность указать провайдер по умолчанию (JCP-656)
* jcp: исправления в инсталляторе (JCP-714, JCP-716, JCP-717, JCP-718, JCP-719, JCP-720)
* jcp: при смене провайдера по умолчанию порядок провайдеров в java.security меняется (JCP-656)
* jcp: доработки в алгоритме использования усиленного контроля использования ключей (JCP-708)
* jcsp: добавлена возможность использовать сертификат с встроенной лицензией (JCP-618)
* jcsp: добавлено обновление списка считывателей при создании объекта провайдера (JCP-712)
* jcsp: доработки в алгоритме использования усиленного контроля использования ключей (JCP-708)
* cades: добавлена возможность задать CRL для проверки сертификатов при создании подписи CAdES-BES (JCP-711)
* cades: добавлена возможность отобразить компоненты CAdES подписи в специальном окне (JCP-395, JCP-721) 
* tls: хранение и редактирование настроек JTLS только под управлением учетной записи администратора (JCP-713)
* tls: исправления в инструкции и адаптере JCPTomcatAdapter в папке Doc\WebServerIntegration\Tomcat9 (JCP-634)

2016-10-04 КриптоПро JCP 2.0.39014
* jcp: исправлена ошибка построения цепочки с сертификатом с истекшим сроком (JCP-705)

2016-09-28 КриптоПро JCP 2.0.38999
* android: добавлена поддержка AArch-64 (CPCSP-6569, JCP-559, JCP-616)
* jcp: доработка ПДСЧ, БиоДСЧ (JCP-673, JCP-681, JCP-682)
* jcp: добавлена поддержка усиленного контроля использования ключей (JCP-676, JCP-683, JCP-696, JCP-694)
* jcp: доработка в связи с изменением метода проверки экспортных ограничений passCryptoPermCheck в java 8 (JCP-647)
* jcp: ужесточена проверка срока действия закрытого ключа (JCP-653)
* jcp: улучшен вывод названий контейнеров (JCP-577)
* jcp: исправлена ошибка декодирования расширения (сертификата), имеющего значение нулевой длины (JCP-657)
* jcp: исправлена ошибка при установке цепочки сертификатов в панели JCP (JCP-666)
* jcp: удалено упоминание датчиков случайных чисел TestPRNG и ConstPRNG (JCP-670)
* jcp: добавлена возможность указать таймаут чтения CRL в JCPRevCheck (JCP-688)
* jcsp: улучшен вывод названий контейнеров (JCP-577)
* jcsp: библиотека libcspjni перемещена в JCSP.jar, добавлен контроль целостности (JCP-644)
* jcsp: добавлена библиотека libcspjni.so для ОС IBM AIX (JCP-488, JCP-636)
* jcsp: удалено упоминание датчиков случайных чисел TestPRNG и ConstPRNG (JCP-670)
* jcsp: добавлен JCSPLicenseLoader (JCP-689)
* cades: исправления в функциях формирования и проверки подписи (JCP-658, JCP-659, JCP-660)
* cades: добавлена возможность создавать подпись по хешу (JCP-669)
* cades: доработана загрузка сертификатов из cacerts (JCP-691)
* samples: добавлен код утилиты tls_proxy, транслирующей http-вызовы в https (JCP-677)
* samples: добавлен код утилиты cmsutil для работы с enveloped-data сообщениями (JCP-678)
* samples: устранено зависание CheckConfFull в Mac OS (JCP-667)
* tls: в папку Doc\WebServerIntegration\Tomcat9 добавлен адаптер JCPTomcatAdapter и инструкция по настройке JTLS в tomcat 9.0.0.M9 (JCP-634)

2016-06-24 КриптоПро JCP 2.0.38830
* jcp: сокращен вывод информации о системе в панели JCP (JCP-633)
* jcp: исправление в макете панели JCP (JCP-641)
* jcp: добавлена проверка алгоритмов подписи и ключа в initSign класса Signature (JCP-643)
* cades: устранена возможность подписать и проверить подпись с использованием недоверенного самоподписанного сертификата (JCP-639)

2016-06-01 КриптоПро JCP 2.0.38815
* jcp: добавлен вывод окна с предупреждением о запрете на подпись ГОСТ Р 34.10-2001 после 31.12.2018 (JCP-589)
* jcp: расширена проверка jar-библиотеки с помощью JarChecker (JCP-586) 
* jcp: реализована блокировка контейнера после 3-х неудачных попыток ввода пароля (JCP-590)
* jcp: добавлены проверки ГОСТ Р 34.10-2012 в SelfTester (JCP-595)
* jcp: в дистрибутив включен XML документ с хешами библиотек, которые можно проверить с помощью вложенного cpverify (JCP-612)
* jcp: добавлено "Описание реализации" (JCP-596)
* cades: сделаны исправления в алгоритме проверки подписи *AdES-T (JCP-619)
* xades: добавлена возможность создавать подпись формата XAdES-X Long Type 1, усовершенствовать BES и T до XAdES-X Long Type 1 (JCP-593)

2016-02-16 КриптоПро JCP 2.0.38674
* jcp: заменена временная лицензия у модулей JCP и JCSP на новую, без ограничений по количеству ядер (JCP-535)
* jcp: добавлена поддержка работы с 512-битными ключами HMAC на основе ГОСТ Р 34.11-2012 (JCP-492)
* jcp: добавлена поддержка режимов паддинга ZERO_PADDING, RANDOM_PADDING (JCP-493)
* jcp: улучшена производительность операций в группе точек эллиптической кривой (JCP-510)
* jcp: оптимизирована работа алгоритма ВКО (JCP-514)
* jcp: оптимизирована работа функции динамического контроля выхода ПДСЧ (JCP-518)
* jcp: исправлена работа маскирования ключевых данных (JCP-526)
* jcp: рефакторинг классов шифраторов (JCP-542, JCP-548, JCP-549, JCP-562, JCP-565, JCP-574)
* android: исправлена ошибка обфускации кода в JInitCSP (JCP-516)
* jcsp: исправлена ошибка при работе с несколькими установленными провайдерами - CSP, HSM и т.п. (JCP-523)
* jcsp: исправлена ошибка избыточного использования clone в GostCipher (JCP-541)
* jcsp: исправлена ошибка переполнения при использовании HMAC (JCP-554, JCP-556)
* jcsp: исправлена ошибка при использовании HMAC в CSP 3.9 (JCP-550)
* jcsp: добавлена фабрика SecretKeyFactory для диверсификации ключа (JCP-551)
* jcsp: добавлена поддержка длинных UKM в алгоритме ВКО (JCP-509)
* cades: выделено общее ядро AdES-core для модулей CAdES и XAdES, рефакторинг CAdES.jar, исправлены ошибки (JCP-540)
* cades: добавлена возможность получить штампы времени после улучшения подписи (JCP-520)
* cades: исправлено некорректное декодирование issuer (JCP-576)
* xades: добавлен модуль XAdES.jar для создания подписи формата XAdES-BES и XAdES-T (JCP-392)
* tls: предотвращена отправка одинаковых issuer в distinguished names (JCP-543)
* tls: добавлен параметр на закладку JTLS "Настройки TLS" для отключения отправки клиентом renegotiation indication (JCP-536)

2015-08-20 КриптоПро JCP 2.0.38481
* jcsp: Добавлена реализация HMAC на основе ГОСТ Р 34.11-94 и ГОСТ Р 34.11-2012 (JCP-480)
* jcp: улучшена производительность алгоритма подписи ГОСТ Р 34.10-2012 (512) (JCP-464)
* jcp: добавление PKUP при создании контейнера и его проверка при подписи (JCP-463)
* jcp: добавлен API для работы с УЦ 2.0, примеры в samples-sources.jar/userSamples/ca20 (JCP-387)
* jcp: добавлен функционал получения открытых ключей ГОСТ Р 34.10-2001 и ГОСТ Р 34.10-2012 по закрытым (JCP-505) 
* jcp: в документацию добавлено описание использования утилиты CMS-шифрования (JCP-477)
* cades: исправлена ошибка установки даты для проверки CRL (JCP-507)
* cades: исправлена ошибка в логировании при работе в Ibm Jre 8 SP 1 (JCP-498)
* cades: добавлено чтение сертификатов из внутеннего штампа при проверке внешнего для построения цепочки сертификатов (JCP-501)
* cades: изменена очередность проверок подписи (JCP-472)
* cades: версия библиотек-зависимостей bouncycastle повышена с 1.46 до 1.50 (JCP-478)
* android: в провайдер ACSP добавлена возможность отключать некоторые типы считывателей (JCP-390)
* android: в провайдер ACSP добавлен пробный набор активити для управления сертификатами, контейнерами, подписи и т.п. (JCP-454)
* android: в ACSPClientApp добавлены примеры работы с активити ACSP, изменена работа с хранилищем доверенных сертификатов (JCP-454)
* android: исправлена ошибка проверки цепочки сертификатов, когда в списке доверенных сертификатов есть несколько из одного УЦ (JCP-499, JCP-500)
* android: исправлена ошибка сохранения лицензии в ACSP (JCP-489)
* android: устранено зависание окна ввода пароля (JCP-508)
* tls: интеграция с Jetty 9.3.1, добавлена инструкция в Doc/WebServerIntegration/Jetty (JCP-460)
* tls: интеграция с JBoss 6.1.0 Final, добавлена инструкция в Doc/WebServerIntegration/JBoss (JCP-388)
* doc: добавлен отдельный документ "Правила пользования" (JCP-459)

2015-04-08 КриптоПро JCP 2.0.38150
* jcp: в описании параметров шифрования TK26 нумерация (1-6) заменена на буквы (A-F) (JCP-420)
* jcp: сделана доработка для устранения ошибки при построении цепочки с кросс-сертификатом в oracle jvm версии 7 и выше (JCP-434)
* jcp: исправлена ошибка - возможное зацикливание проверки цепочки сертификатов при использовании CPPKIX в ibm jvm (JCP-435)
* jcp: устранено излишнее логирование в классах хеширования *Digest (JCP-436)
* jcp: введен запрет на использование ключа подписи в TransportCipher (JCP-425)
* jcp: в J6CF протокол T=0 заменен на * (JCP-190)
* jcp: добавлена кнопка для сброса параметров по умолчанию на вкладке "Алгоритмы" в панели JCP (JCP-415, JCP-421)
* jcp: добавлен установщик модулей setup.exe (и setup_console.bat <JRE>) для Windows и setup_gui.sh <JRE> (setup_console.sh <JRE>) для *nix (JCP-389) 
* jcp: исправлена ошибка - в Mac OS компоненты панели JCP, доступные root, оказывались активными и для пользователей (JCP-411)  
* jcp: оптимизация работы с кривыми Эдвардса и новым БиоДСЧ (JCP-346, JCP-438, JCP-356)
* cades: доработан Enveloped CMS API, добавлена возможность создания key_agreement структуры (JCP-424)
* android: в приложении ACSPClientApp обновлены тестовые контейнеры (JCP-431)
* android: в приложение ACSPClientApp добавлены примеры Enveloped CMS (JCP-440)
* jcsp: добавлен TransportCipher с алгоритмом GostTransport (JCP-425)
* tls: добавлена возможность установить лицензию JTLS в командной строке (JCP-451)

2014-12-25 КриптоПро JCP 2.0.37985
* jcsp: добавлена поддержка MacOS для провайдера Java CSP (JCP-379)
* jcp: добавлена реализация скрученных эллиптических кривых в форме Эдвардса и соответствующих наборов параметров (JCP-346)
* jcp: доработан БиоДСЧ (JCP-356, JCP-403)
* jcp: сняты ограничения по использованию старых параметров подписи и обмена ГОСТ Р 34.10-20хх (JCP-406, JCP-415)
* jcp: добавлен алгоритм импорта/экспорта PRO12_EXPORT сессионного ключа (JCP-345)
* jcp: в дистрибутив JCP добавлены инструкции по интеграции JTLS с IBM WAS 8.5 и Glassfish 4 (JCP-370, JCP-382, JCP-383)
* cades: исправлена ошибка - могла образоваться неправильная очередность ссылок на доказательства (JCP-398)
* cades: исправлена ошибка - формируемый при поиске в подписи OCSP-доказательств cert_id не всегда соответствовал cert_id, вложенному в OCSP-ответ (JCP-399)
* cades: добавлены методы получения атрибутов из подписи, вложенных сертификатов и CRL (JCP-158)
* android: переработано приложение ACSPClientApp - выполнение примеров с контейнерами на любом поддерживаемом носителе и алгоритме (JCP-355)
* android: версия Android SDK API приложения ACSPClientApp повышена с 10 до 14 (JCP-412)
* android: в ACSPClientApp убрана кнопка генерации ключей подписи (JCP-416) 
* tls: удалены устаревшие модули xjsse4.jar, TomCat.jar, поправлена документация (JCP-344, JCP-366, JCP-400)

2014-11-19 КриптоПро JCP 2.0.37886
* jcp: доработан JCPRequest для поддержки изменений в новых версиях УЦ (JCP-358)
* jcp: обновлен сертификат подписи jar-библиотек (JCP-352)
* jcp: уточнена информация в поле required license панели JCP (JCP-364)
* jcp: исправлены ошибки взаимодействия с параметрами в панели JCP (JCP-374)
* jcp: доработка документации (JCP-344, JCP-373)
* tls: интеграция с IBM Websphere Application Server 8.5.5.3 (JCP-359)
* cades: доработка CAdES API, добавлены примеры подписи с использованием ГОСТ 2012, примеры создания/проверки CAdES подписи в Android (JCP-289, JCP-357)
* cades: добавлен поиск сертификата подписи по signature id в функции enhance в CAdES API (JCP-361)
* xml: из Android-сборки убран XMLDSigRI, из ACSPClientApp удален пример работы с ним (JCP-349)
* asn: исправлено кодирование дат ResponseData (данные OCSP ответа) в ASN1P (JCP-362)
* asn: исправлена работа провайдера с контейнерами, имена которых содержат буквы русского алфавита (JCP-272, JCP-342)
* jcsp: добавлена поддержка RAW-алгоритмов (JCP-353)
* internal: (JCP-174, JCP-208, JCP-347, JCP-351, JCP-360, JCP-365, JCP-368)

2014-08-21 КриптоПро JCP 2.0.37748
* jcp: значительно ускорено хеширование на алгоритмах ГОСТ Р 34.11-2012 (JCP-309)
* jcp: расширен функционал для ЭЦП, работы с контейнерами, согласования ключей на алгоритме ГОСТ Р 34.10-2012 (512 бит); JCP поддержал сайферсюиту TLS_CIPHER_2012 в JTLS; доработана панель ControlPane (JCP-284, JCP-311, JCP-317)
* jcp: ликвидирован ГОСТ Р 34.10-94 (проверка подписи, параметры, старые названия алгоритмов), перегенерирован ASN1P (JCP-314)
* jcp: исправлена ошибка в getEntry: невозможно было открыть контейнер без сертификата (JCP-313)
* jcp: исправлена ошибка в панели: для установки сертификата в контейнер на отделяемом носителе в setCertificateEntry() не передавался пароль (JCP-326)
* jcp: добавлен контроль целостности провайдеров (проверка ЭЦП модулей JCP.jar, JCryptoP.jar и JCSP.jar), сделаны изменения в установочных скриптах (JCP-316, JCP-327)
* jcp: для версии 2.0 введены новые параметры для хранения даты установки JCP и JTLS и их серийных номеров (JCP-312)
* jcp: добавлено обновление всего списка контейнеров отделяемого носителя в панели JCP при смене пароля (JCP-336)
* tls: ликвидирована сайферсюита TLS_CIPHER_94 (JCP-314)
* jcsp: libcspjni в Java CSP теперь кроме CSP 4.0 работает с CSP 3.6 и CSP 3.9 (JCP-332)
* jcsp: добавлена закладка "Настройки Java CSP" для указания имен провайдеров заданного типа по умолчанию (JCP-322)
* jcsp: исправлена ошибка: не удавалось прочитать длинную цепочку сертификатов из контейнера (JCP-329)
* jcsp: исправлена ошибка: смена пароля у контейнера без сертификата приводила к ошибке (JCP-337)
* cades: изменения в CAdES API для поддержки поточной подписи, добавлены примеры в samples.jar/CAdES (JCP-347)
* cades: добавлен Enveloped CMS API в модуль CAdES.jar, примеры в samples.jar/CAdES/enveloped (JCP-333)
* cades: отключена попытка при формировании подписи CAdES-X Long Type 1 получить CRL, если в сертификате подписи нет AIA или недоступны OCSP службы (JCP-174)
* xml: у JCPxml обновлена зависимость xmlsec с версии 1.4.* до 1.5.0 для соответствия XMLDSigRI.jar (JCP-207)
* xml: в JCPxml добавлены urn алгоритмов подписи и хеширования ГОСТ Р 34.11/34.10-2012 (JCP-290)
* android: доработка JCPxml для работы в Android. В ACSPClientApp добавлен пример XMLSignVerifyExample подписи/проверки XML документа (JCP-349) 
* android: удалена закладка "Информация" (Information) в ACSP (JCP-330)
* android: исправления в libcspjni.so для Android L (JCP-325)
* internal: (JCP-310, JCP-318, JCP-321, JCP-324, JCP-334, JCP-335, JCP-338, JCP-339, JCP-340, JCP-352)

2014-05-12 КриптоПро JCP 2.0.37538
* jcp: добавлены методы engineGetEntry и engineSetEntry в JCP (JCP-174)
* jcsp: добавлен новый провайдер Java CSP 
* jcp: панель JCP выделена в отдельный модуль JCPControlPane, добавлена возможность использовать провайдер Java CSP в панели JCP для операций с контейнерами (JCP-307)
* jcp: изменен формат документации (PDF), внесены дополнения (JCP-294)
* jcsp: провайдер Java CSP можно использовать в ОС Windows/Linux (JCP-174)
* jcsp: функционал провайдеров JCSP_2012_* объединен с JCSP: сами JCSP_2012_* ликвидированы. Сделаны соответствующие исправления в приложении ACSPClientApp (JCP-306)
* jcsp: добавлена функция setCertificateEntry в JCSP (JCP-249)
* jcsp: провайдер Java CSP можно использовать в tomcat (с поддержкой TLS_CIPHER_2012) (JCP-174)
* internal: исправления в CheckConfFull, примерах (samples.jar), bat/sh скриптах (JCP-258, JCP-308)

2014-02-27 КриптоПро JCP 2.0.37363
* android: добавлена поддержка ГОСТ 2012 в TLS (новая cipher suite - TLS_CIPHER_2012), примеры (JCP-288)
* android: исправлена ошибка в контроле целостности (JCP-174)
* tls: добавлена обработка параметров в SSLContextImpl при загрузке апплета (JCP-182)
* tls: добавлена поддержка renegotiation indication extension в JTLS (по умолчанию "поддерживается"); свойства доступны на вкладке "Настройки" JTLS (см. док.) (JCP-112)
* tls: исправлена ошибка: client auth requested воспринимался, как client auth required (JCP-296)
* jcp: добавлен класс JCPProtectionParameter для задания пароля и режима SILENT в getEntry для JCSP (JCP-298)
* jcp: тип ОГРНИП исправлен на NumericString; добавлен 1.2.840.113549.1.9.2 (unstructured, Utf8String); типы всех полей, кроме E, C и DC, исправлены на Utf8String (JCP-301)
* jcp: для поддержки КриптоПро УЦ 1.5 добавлены два http-клиента для систем Windows/*nix и Android: стандартный (HttpUrlConnection) и на базе apache http client 4 (JCP-303)
* jcp: добавлен класс ru.CryptoPro.JCP.Util.SetPrefs для установки настроек в командой строке (JCP-299)
* internal: (JCP-295, JCP-293, JCP-302)

2014-01-22 КриптоПро JCP 2.0.37283
* jcp: изменена версия лицензии продукта, принимается лицензия только версии 2.0 (JCP-279, JCP-259)
* jcp: раскрытие списка контейнеров в панели JCP одним кликом (JCP-273)
* jcp: добавлен класс JCPPrivateKeyEntry для работы с Entry-объектами (JCP-174)
* jcp: исправления в поведении контрольной панели на MacOS (JCP-88)
* jcp: реализована смена пароля на e-token aladdin, добавлены несколько классов исключений: переполнение токена, исчерпание лимита попыток смены пароля (JCP-286)
* asn: расширен и обновлен список классов, ликвидированы классы JCP_* и Lite_* (JCP-278, JCP-277)
* samples: исправлена ошибка в CheckConfFull, заключающаяся в выводе ОК, даже если проверка модуля FAIL (JCP-174)
* android: выбор считывателей на андроиде (JCP-275)
* android: добавлен метод CSPConfig.registerActivityContext(this) в JInitJCSP для корректного отображения при смене activity окна ДСЧ, окна ввода пароля (JCP-287)
* andriod: модификация JCSP, JCP, JCPRequest, JCPRevCheck, cpSSL для Android (JCP-242)
* android: обновлен ключ подписи apk (JCP-261)
* tls: пакет ru.CryptoPro.ssl.java6 совмещен с пакетом ru.CryptoPro.ssl в модуле cpSSL (JCP-174)
* cades: удалены несколько сокращенных методов addSigner, изменены примеры для будущего использования ГОСТ 2012 (JCP-174)
* internal: контроль целостности в ACSP.apk выполняется на алгоритме ГОСТ Р 34.11-2012 (256 бит) (JCP-285)
* internal: добавление в JCSP генерации ключевых пар, ЭЦП, хеширования, параметров шифрования на алгоритме ГОСТ 2012, расширены примеры demo-приложения (JCP-281)
* internal: изменения в логгере для корректной работы в jboss (JCP-276)
* internal: изменения в документации (JCP-214)
* internal: (JCP-200, JCP-248, JCP-282, JCP-279, JCP-259)

2013-09-05 КриптоПро JCP 2.0.37027
* jcp: функционирует только в sun/ibm jvm версии 1.6 и выше (JCP-245)
* jcp: исправлена ошибка при установке на sun jre 1.7.0_25 (JCP-174)
* jcp: исправлена ошибка при использовании слеша в названии контейнера (JCP-253)
* jcp: исправлен тип ИНН, ОГРН и СНИЛС при добавлении в запрос на сертификат (формат NumericString) (JCP-263)
* jcp: доработана и поправлена документация (JCP-174, JCP-265)
* jcp: обновлены ключи подписи jar-библиотек (sun, квалифицированный ГОСТ сертификат) (JCP-261, JCP-270)
* jcp: добавлен вывод кода ошибки и сообщения в установочных скриптах (JCP-258)
* internal: расширена проверка в CheckConfFull (JCP-256) 
* internal: (JCP-254, JCP-242)
* tls: исправлена ошибка зависания при чтении большого certificate request (JCP-238)

2013-07-01 КриптоПро JCP 1.0.56
* jcp: доработаны TLS-примеры, добавлены нагрузочные TLS-тесты (JCP-174)
* cades: устанавливается отдельно от JCP (JCP-155)
* tls: возможность вывода дампа обмена в лог на уровне ALL (JCP-233)
* jcp: исправления в контрольной панели (JCP-174)
* jcp: добавлена установка кода ошибки в инсталляционных скриптах (JCP-230)
* internal: (JCP-232)
* internal: исправления в логгере JCPLogger (JCP-236, JCP-232)

2013-04-09 КриптоПро JCP 1.0.55
* jcp: исправлена ошибка сброса пароля после добавления в хранилище сертификатов нового сертификата (JCP-235)
* jcp: исправлена ошибка повторного появления окна для создания хранилища сертификатов (JCP-235)
* tls: переделана процедура построения и проверки цепочки сертификатов (JCP-234) 
* tls: расширен интерфейс для задания параметров проверки цепочки сертификатов на вкладке с настройками (JCP-237)

2013-03-13 КриптоПро JCP 1.0.54 (сертифицированная версия)
* samples: добавлены примеры использования CAdES API (JCP-160)
* samples: добавлен пример использования apache http client 4.x + jtls (JCP-127, JCP-188)
* samples: добавлены примеры работы с wss4j 1.6.3 (JCP-147, JCP-149)
* samples: добавлены примеры работы с xmldsigri по JSP 105 (JCP-144, JCP-145)
* samples: добавлены примеры работы с УЦ CA15 (JCP-174)
* samples: добавлен пример обращения в zapret-info (JCP-174)
* samples: добавлен пример обмена java-клиента (wss4j 1.6.3) и .net-сервиса (SOAP XML, EncryptedKey + DerivedKeyToken), подписи, шифрование (JCP-218)
* samples: добавлен пример добавления в CAdES-подпись параллельной подписи (JCP-155)
* samples: добавлен пример создания CAdES-подписи по хешу сообщения (JCP-155) 
* samples: исправление ошибки декодирования сертификата в примере getCert (JCP-174)
* samples: функции проверки CMS-подписи в пакетах CMS и CMSVerify (ф. CMS и CMSVerify) объявлены deprecated (JCP-174)
* xml: добавлена поддержка ГОСТ алгоритмов в виде urn (JCP-146)
* xml: добавлена возможность передачи в контекст подписи или валидации провайдера подписи и хеширования (JCP-146)
* xml: добавлена поддержка алгоритма подписи на симметричном ключе hmac-gostr3411 (JCP-218)
* jcp: расширен вывод ru.CryptoPro.JCP.tools.Check -all: вывод версии, build-номера, preferences (JCP-151)
* jcp: добавлен вывод номера лицензии в консоль (JCP-185)
* jcp: не генерились ключи в хранилище /var/opt/cprocsp, т.к. неверно задавались права при установке JCP (JCP-120)
* jcp: исправлена ошибка, позволявшая выбрать вид аутентификации "серверная" даже для ключа типа signature (JCP-178)
* jcp: можно было задать при генерации запроса email только в виде EMail=email@a.ru, теперь можно и E=email@a.ru (JCP-153)
* jcp: исправлена ошибка, при которой генерируемый контейнер без пароля получал пароль от удаленного или сгенеренного перед этим контейнера с паролем (JCP-183)
* jcp: убрано исключение при добавлении нового certificate store, если список пуст (JCP-103)
* jcp: убрано появление окна выбора сертификата, когда при выделенном закрытом контейнере нажимаем "Добавить сертификат", вызывается окно ввода пароля, жмем "Отмена", и все равно появляется окно для выбора сертификата (JCP-184)
* jcp: убраны лишние запросы пароля при отмене операции открытия хранилища (JCP-184)
* jcp: убраны лишние появления сообщения о неправильном пароле при нажатии "Отмена" (JCP-184)
* jcp: восстановлен вывод списка модулей в виде таблицы (build-номер, версия, путь) на вкладке "Дополнительно" (JCP-179)
* jcp: замена большинства getInstance(algorithm) на getInstance(algorithm, provider) (JCP-78)
* jcp: добавлена возможность генерить запрос PKCS10 на сертификат в контейнере, полученном, например, из csp (при наличии ключа в контейнере или ключа и сертификата) (JCP-90)
* jcp: добавлен вывод окна с сообщением об использовании ключа с усиленной защитой (user protected), продолжительность появления окна можно регулировать на вкладке "Дополнительно" (JCP-166)
* jcp: автодобавление слеша в путь FloppyStore и HDImageStore (JCP-174)	
* internal: исправления в JCPLogger (JCP-210)
* cades: исправлено некорректное в некоторых случаях извлечение аттрибутов подписи - ссылок на доказательства (JCP-212)
* cades: исправления в процедуре проверки цепочки сертификатов в CAdES-BES подписи по CRL онлайн (JCP-219, JCP-226) 
* cades: поправлена ошибка при построении и проверке цепочки сертификатов в sun, ibm (JCP-177)
* cades: исправлена ошибка, позволявшая создать CAdES-BES подпись, используя отозванный сертификат (JCP-201)
* cades: большинство методов генерируют только один вид исключения - CAdESException (JCP-155)
* cades: добавлена возможность задать провайдер подписи и хеширования (JCP-155)
* cades: правки в документации и примерах (JCP-156)
* cades: проверка срока действия ключа выполняется только у сертификата подписи службы штампов (TSA), а не у всех сертификатов из цепочки (JCP-181)
* cades: добавлена возможность помещать подписываемые и неподписываемые аттрибуты в ЭЦП (JCP-225)
* cades: добавлена возможность помещать сертификаты и CRL в ЭЦП (JCP-225)
* asn: поправлено декодирование SignedData в части сертификатов и СОС, упакованных в структуру с неопределенным размером (JCP-209)
* asn: добавлена возможность проверять ЭЦП CMS по неотсортированным подписываемым аттрибутам (по умолчанию они сортируются) (JCP-209)
* jcp: добавлен API для обращения к УЦ CA 1.5 (пакет ru/CryptoPro/JCPRequest/ca15) (JCP-204)
* jcp: добавлены СНИЛС, ИНН, ОГРН (JCP-222)
* internal: (JCP-211)
* tls: переход на java версии 1.6 и 1.7 (JCP-174)
* tls: поддержка apache http client 4.x (JCP-127)
* tls: изменения в логгере SSLLogger (JCP-210)

2012-05-12 КриптоПро JCP 1.0.53
* jcp: исправлена ошибка, при которой File.createTempFile использовал TestPRNG вместо CPRandom при вызове SecureRandom, когда в списке ДСЧ первым оказывался TestPRNG (JCP-170)
* jcp: изменена логика работы установщика JCP, дабы не считать ошибкой невозможность проверки подписи (необходимо в ibm jvm) (JCP-134)
* tls: исправлена ошибка в JTLS, при которой сервер пропускал самоподписанный сертификат клиента (JCP-174)
* tls: изменено правило проверки при вводе номера серверной лицензии (JCP-171)
* tls: добавлена возможность проверки имени компании в формате BASE64 в JTLS (JCP-150)

2011-12-06 КриптоПро JCP 1.0.52
* tls: временная лиценизия на JTLS больше не содержит ограничения на число соединений (JCP-111)
* jcp: исправлены ошибки обфускации (JCP-138)
* jcp: добавлена возможность реализовывать свои биодатчики (CP-141)
* jcp: добавлены алгоритмы подписи без хэширования (JCP-140)
* jcp: снята проверка лицензии при загрузке сертификатов из контейнера; оставлена только на чтении закрытых ключей (CP-141)
